

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess &mdash; SmartRecruiting back v2 documentation</title>
  

  
  
  
  

  
  <script type="text/javascript" src="../../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../../" src="../../../../_static/documentation_options.js"></script>
        <script type="text/javascript" src="../../../../_static/jquery.js"></script>
        <script type="text/javascript" src="../../../../_static/underscore.js"></script>
        <script type="text/javascript" src="../../../../_static/doctools.js"></script>
        <script type="text/javascript" src="../../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../../index.html" class="icon icon-home"> SmartRecruiting back
          

          
          </a>

          
            
            
              <div class="version">
                v2
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../install.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../contributing.html">Contributing</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../documentation.html">Backend documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">SmartRecruiting back</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
        
      <li>SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess</h1><div class="highlight"><pre>
<span></span><span class="ch">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># License : GNU General Public License</span>
<span class="c1"># Authors: Romain Guillot, Alicia</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="sd">Preprocessing of texts, using the removal of stop words and the Word2Vec to create descriptors.</span>

<span class="sd">Text descriptor format : python list (size = config) of numpy array (size = config)</span>

<span class="sd">Wikipedia FR corpus (2008) : http://redac.univ-tlse2.fr/corpora/wikipedia_en.html</span>
<span class="sd">Stats :</span>
<span class="sd">- Nb words : 284 472 742</span>
<span class="sd">- Nb lines : 37 654 166</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="kn">import</span> <span class="nn">csv</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">nltk</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">gensim.models</span> <span class="k">import</span> <span class="n">Word2Vec</span>

<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd</span> <span class="k">import</span> <span class="n">app</span><span class="p">,</span> <span class="n">get_path</span>
<span class="kn">from</span> <span class="nn">.utils</span> <span class="k">import</span> <span class="n">plot</span> <span class="k">as</span> <span class="n">plot_words</span>
<span class="kn">from</span> <span class="nn">.database_handler</span> <span class="k">import</span> <span class="n">add_offer_to_database</span><span class="p">,</span> <span class="n">add_contacts</span><span class="p">,</span> <span class="n">add_fields</span>
<span class="kn">from</span> <span class="nn">..utils</span> <span class="k">import</span> <span class="n">stop_words</span><span class="p">,</span> <span class="n">error</span>


<span class="c1"># Constants declarations</span>
<span class="n">STOP_LIST</span> <span class="o">=</span> <span class="n">stop_words</span><span class="p">()</span>
<span class="n">max_size</span> <span class="o">=</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;max_size_offers&#39;</span><span class="p">]</span>  <span class="c1"># The maximal size that a text should have.</span>


<div class="viewcode-block" id="get_wikipedia_corpus"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.get_wikipedia_corpus">[docs]</a><span class="k">def</span> <span class="nf">get_wikipedia_corpus</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Get content from the wikipedia corpus (filename specified in config file).</span>
<span class="sd">    This function read the corpus text file, and add lines to the result. A limit can be specified in the config</span>
<span class="sd">    file to not process all lines.</span>

<span class="sd">    :return: list containing lines from the wikipedia corpus</span>
<span class="sd">    :rtype: list of str</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">lines</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">limit</span> <span class="o">=</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;word2vec&#39;</span><span class="p">][</span><span class="s1">&#39;maxlines_wiki_corpus&#39;</span><span class="p">]</span>
    <span class="n">i</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;word2vec&#39;</span><span class="p">][</span><span class="s1">&#39;filename_wiki_corpus&#39;</span><span class="p">],</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;iso-8859-1&#39;</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s1">&#39;r&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">line</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">readline</span><span class="p">()</span>
            <span class="k">while</span> <span class="n">line</span> <span class="ow">and</span> <span class="n">i</span> <span class="o">&lt;</span> <span class="n">limit</span><span class="p">:</span>
                <span class="n">cleaned</span> <span class="o">=</span> <span class="n">tokenize</span><span class="p">(</span><span class="n">line</span><span class="p">)</span>
                <span class="n">lines</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">cleaned</span><span class="p">)</span>
                <span class="n">line</span> <span class="o">=</span> <span class="n">f</span><span class="o">.</span><span class="n">readline</span><span class="p">()</span>
                <span class="n">i</span> <span class="o">+=</span> <span class="mi">1</span>
                <span class="k">if</span> <span class="n">i</span> <span class="o">%</span> <span class="mi">10000</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
                    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Still &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">limit</span> <span class="o">-</span> <span class="n">i</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot; lines to process.&quot;</span><span class="p">,</span> <span class="n">flush</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">end</span><span class="o">=</span><span class="s2">&quot;</span><span class="se">\r</span><span class="s2">&quot;</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">Exception</span><span class="p">:</span>
        <span class="n">error</span><span class="p">(</span><span class="s2">&quot;Unable to get wikipedia corpus. Verify your corpus filename in your config file.&quot;</span><span class="p">)</span>

    <span class="k">return</span> <span class="n">lines</span></div>


<div class="viewcode-block" id="build_word2vec"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.build_word2vec">[docs]</a><span class="k">def</span> <span class="nf">build_word2vec</span><span class="p">(</span><span class="n">offers</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This function builds a Word2Vec neural network model. This model produces vector for each word in our vocabulary.</span>
<span class="sd">    Word2vec also build our vocabulary with our [sentences].</span>

<span class="sd">    This model will be trained on wikipedia corpus and offers :</span>

<span class="sd">    * from the offers csv file if offers is null</span>
<span class="sd">    * from the [offers] parameter else</span>

<span class="sd">    Offers csv filename and wikipedia corpus filename are defined in the config file.</span>

<span class="sd">    .. note::</span>
<span class="sd">        Word2vec model parameters can be changed in the config file.</span>

<span class="sd">    .. note::</span>
<span class="sd">        We have also add a padding words in the vocabulary to be able to pad texts with this word</span>

<span class="sd">    :param offers: (optional) offers used to train the model (else, offers from the CSV used)</span>
<span class="sd">    :type: list of dictionary with at least {&#39;content: str }</span>

<span class="sd">    :return: Word2Vec model trained on [sentences]</span>
<span class="sd">    :rtype: Word2Vec</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Build word2vec model ...&quot;</span><span class="p">)</span>
    <span class="n">filename</span> <span class="o">=</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;offers_dataset&#39;</span><span class="p">]</span>
    <span class="n">sentences</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">if</span> <span class="n">offers</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">filename</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;utf-8&#39;</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;r&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">reader</span> <span class="o">=</span> <span class="n">csv</span><span class="o">.</span><span class="n">DictReader</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">row</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">reader</span><span class="p">):</span>
                <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;init offer &#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span> <span class="o">+</span> <span class="mi">1</span><span class="p">),</span> <span class="n">end</span><span class="o">=</span><span class="s2">&quot;</span><span class="se">\r</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">flush</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
                <span class="n">text</span> <span class="o">=</span> <span class="n">row</span><span class="p">[</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;feature&#39;</span><span class="p">]]</span>  <span class="c1"># Get the text from the initial offer</span>
                <span class="n">sentences</span> <span class="o">+=</span> <span class="p">[</span><span class="n">tokenize</span><span class="p">(</span><span class="n">text</span><span class="p">)]</span>  <span class="c1"># Sentences used to build the model&#39;s vocabulary</span>

    <span class="k">else</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">o</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">offers</span><span class="p">):</span>
            <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;reinit offer &#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span> <span class="o">+</span> <span class="mi">1</span><span class="p">),</span> <span class="n">end</span><span class="o">=</span><span class="s2">&quot;</span><span class="se">\r</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">flush</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
            <span class="n">text</span> <span class="o">=</span> <span class="n">o</span><span class="p">[</span><span class="s1">&#39;content&#39;</span><span class="p">]</span>
            <span class="n">sentences</span> <span class="o">=</span> <span class="n">sentences</span> <span class="o">+</span> <span class="p">[</span><span class="n">tokenize</span><span class="p">(</span><span class="n">text</span><span class="p">)]</span>  <span class="c1"># Sentences used to build the model&#39;s vocabulary</span>
    <span class="nb">print</span><span class="p">()</span>  <span class="c1"># Print a new line to not override lines below</span>
    <span class="n">sentences</span><span class="o">.</span><span class="n">extend</span><span class="p">(</span><span class="n">get_wikipedia_corpus</span><span class="p">())</span>
    <span class="nb">print</span><span class="p">()</span>  <span class="c1"># Print a new line to not override lines below</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">model</span> <span class="o">=</span> <span class="n">Word2Vec</span><span class="p">(</span><span class="n">sentences</span><span class="p">,</span> <span class="n">size</span><span class="o">=</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;word_vector_dim&#39;</span><span class="p">],</span> <span class="n">window</span><span class="o">=</span><span class="mi">20</span><span class="p">,</span> <span class="n">min_count</span><span class="o">=</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;word2vec&#39;</span><span class="p">][</span><span class="s1">&#39;min_freq&#39;</span><span class="p">],</span> <span class="n">workers</span><span class="o">=</span><span class="mi">4</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">RuntimeError</span><span class="p">:</span>
        <span class="n">error</span><span class="p">(</span><span class="s2">&quot;Unable to train Word2Vec. Maybe you have not enough data to train the model, consider reduce min-freq in your config file.&quot;</span><span class="p">,</span> <span class="n">critic</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">Exception</span><span class="p">:</span>
        <span class="n">error</span><span class="p">(</span><span class="s2">&quot;Unexpected error while train Word2Vec.&quot;</span><span class="p">,</span> <span class="n">critic</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

    <span class="n">model</span><span class="o">.</span><span class="n">wv</span><span class="p">[</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;padding_str&#39;</span><span class="p">]]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="mi">0</span><span class="p">]</span> <span class="o">*</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;word_vector_dim&#39;</span><span class="p">])</span>  <span class="c1"># Add a descriptor for the padding word</span>
    <span class="n">model</span><span class="o">.</span><span class="n">save</span><span class="p">(</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;word2vec&#39;</span><span class="p">][</span><span class="s1">&#39;save_path&#39;</span><span class="p">])</span>
    <span class="k">if</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;debug&#39;</span><span class="p">][</span><span class="s1">&#39;visualisation_w2c&#39;</span><span class="p">]</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
        <span class="n">plot_words</span><span class="p">(</span><span class="n">model</span><span class="p">,</span> <span class="n">max_words</span><span class="o">=</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;debug&#39;</span><span class="p">][</span><span class="s1">&#39;max_word_to_plot&#39;</span><span class="p">])</span>
    <span class="k">return</span> <span class="n">model</span></div>


<div class="viewcode-block" id="load_word2vec"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.load_word2vec">[docs]</a><span class="k">def</span> <span class="nf">load_word2vec</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Load the word2vec model from the file defined in the config file.</span>
<span class="sd">    If an error occurred (typically the file doesn&#39;t exists) we exit the execution.</span>

<span class="sd">    .. note::</span>
<span class="sd">        If want want to build the word2vec model consider using the build_word2vec method.</span>

<span class="sd">    :return: The word2vec model</span>
<span class="sd">    :rtype: Word2Vec</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Load word2vec model ...&quot;</span><span class="p">)</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">model</span> <span class="o">=</span> <span class="n">Word2Vec</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">get_path</span><span class="p">(</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;word2vec&#39;</span><span class="p">][</span><span class="s1">&#39;save_path&#39;</span><span class="p">]))</span>
        <span class="k">if</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;debug&#39;</span><span class="p">][</span><span class="s1">&#39;visualisation_w2c&#39;</span><span class="p">]</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">plot_words</span><span class="p">(</span><span class="n">model</span><span class="p">,</span> <span class="n">max_words</span><span class="o">=</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;debug&#39;</span><span class="p">][</span><span class="s1">&#39;max_word_to_plot&#39;</span><span class="p">])</span>
        <span class="k">return</span> <span class="n">model</span>
    <span class="k">except</span> <span class="ne">Exception</span><span class="p">:</span>
        <span class="n">error</span><span class="p">(</span><span class="n">message</span><span class="o">=</span><span class="s2">&quot;Unable to load word2vec model.</span><span class="se">\n</span><span class="s2">Consider using --word2vec to build the model.&quot;</span><span class="p">)</span>
        <span class="n">exit</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span></div>


<div class="viewcode-block" id="tokenize"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.tokenize">[docs]</a><span class="k">def</span> <span class="nf">tokenize</span><span class="p">(</span><span class="n">text</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function  to tokenize the [text]. Following steps are done to tokenize the [text] :</span>
<span class="sd">    1. Lowercase + remove whitespaces</span>
<span class="sd">    2. Keep only numbers</span>
<span class="sd">    3. Remove punctuations</span>
<span class="sd">    4. Tokenize the text into words</span>
<span class="sd">    5. For each word, if it is not in stopwords list, we add the stem of the word to the return result</span>

<span class="sd">    :param text: input text to tokenize</span>
<span class="sd">    :type text: str</span>

<span class="sd">    :return: list of words</span>
<span class="sd">    :rtype: list of str</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">stemmer</span> <span class="o">=</span> <span class="n">nltk</span><span class="o">.</span><span class="n">stem</span><span class="o">.</span><span class="n">snowball</span><span class="o">.</span><span class="n">FrenchStemmer</span><span class="p">()</span>

    <span class="n">text</span> <span class="o">=</span> <span class="n">text</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>  <span class="c1"># Lower + remove whitespaces</span>
    <span class="n">text</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">sub</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;\d+&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="n">text</span><span class="p">)</span>  <span class="c1"># Remove numbers</span>
    <span class="n">text</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">sub</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;[?|!|</span><span class="se">\&#39;</span><span class="s1">|&quot;|#|.|,|)|(|\|/]&#39;</span><span class="p">,</span> <span class="sa">r</span><span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="n">text</span><span class="p">)</span>  <span class="c1"># Remove punctuation</span>
    <span class="n">text</span> <span class="o">=</span> <span class="n">nltk</span><span class="o">.</span><span class="n">word_tokenize</span><span class="p">(</span><span class="n">text</span><span class="p">)</span>  <span class="c1"># tokenize</span>
    <span class="n">res</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">word</span> <span class="ow">in</span> <span class="n">text</span><span class="p">:</span>  <span class="c1"># Add stemmed words to result, except if this word is in the stop list</span>
        <span class="k">if</span> <span class="n">word</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">STOP_LIST</span><span class="p">:</span>
            <span class="n">res</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">stemmer</span><span class="o">.</span><span class="n">stem</span><span class="p">(</span><span class="n">word</span><span class="p">))</span>
    <span class="k">return</span> <span class="n">res</span></div>


<div class="viewcode-block" id="preprocess"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.preprocess">[docs]</a><span class="k">def</span> <span class="nf">preprocess</span><span class="p">(</span><span class="n">text</span><span class="p">,</span> <span class="n">model</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to get a text descriptor from the [text]. Following steps are done :</span>
<span class="sd">    1. Tokenize text (see tokenize function)</span>
<span class="sd">    2. Normalization of the [text] lenght (padding or truncating)</span>
<span class="sd">    3. From the vocabulary of our Word2Vec model, we get the words representations</span>

<span class="sd">    :param text: the input text</span>
<span class="sd">    :type text: str</span>

<span class="sd">    :param model: word2vec model which contains words and words descriptor</span>
<span class="sd">    :type model: Word2Vec</span>

<span class="sd">    :return: Word representations (each word is a float numpy array)</span>
<span class="sd">    :rtype: list of numpy array</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">cleaned</span> <span class="o">=</span> <span class="n">tokenize</span><span class="p">(</span><span class="n">text</span><span class="p">)</span>
    <span class="n">words</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="nb">filter</span><span class="p">(</span><span class="k">lambda</span> <span class="n">x</span><span class="p">:</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">model</span><span class="o">.</span><span class="n">wv</span><span class="o">.</span><span class="n">vocab</span><span class="p">,</span> <span class="n">cleaned</span><span class="p">))</span>  <span class="c1"># keep only words present in the model vocabulary</span>

    <span class="c1"># Trunc or padding text to normalize length</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">words</span><span class="p">)</span> <span class="o">&gt;=</span> <span class="n">max_size</span><span class="p">:</span>
        <span class="n">words</span> <span class="o">=</span> <span class="n">words</span><span class="p">[:</span><span class="n">max_size</span><span class="p">]</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">words</span> <span class="o">=</span> <span class="n">words</span> <span class="o">+</span> <span class="p">[</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;padding_str&#39;</span><span class="p">]]</span> <span class="o">*</span> <span class="p">(</span><span class="n">max_size</span> <span class="o">-</span> <span class="nb">len</span><span class="p">(</span><span class="n">words</span><span class="p">))</span>
    <span class="n">descriptor</span> <span class="o">=</span> <span class="p">[</span><span class="n">model</span><span class="o">.</span><span class="n">wv</span><span class="p">[</span><span class="n">w</span><span class="p">]</span> <span class="k">for</span> <span class="n">w</span> <span class="ow">in</span> <span class="n">words</span><span class="p">]</span>

    <span class="k">return</span> <span class="n">descriptor</span></div>


<div class="viewcode-block" id="preprocess_all_and_add_to_database"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.preprocess_all_and_add_to_database">[docs]</a><span class="k">def</span> <span class="nf">preprocess_all_and_add_to_database</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">file_name</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to preprocess the offers from a csv film [file_name] and add them in the database.</span>
<span class="sd">    See preprocess function to know more about the preprocess operations.</span>

<span class="sd">    :param file_name: name of the file containing the data to process</span>
<span class="sd">    :type file_name: str</span>

<span class="sd">    :param db_manager: database manager</span>
<span class="sd">    :rtype db_manager: DatabaseManager</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;utf-8&#39;</span><span class="p">,</span> <span class="n">mode</span><span class="o">=</span><span class="s2">&quot;r&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">reader</span> <span class="o">=</span> <span class="n">csv</span><span class="o">.</span><span class="n">DictReader</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">row</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">reader</span><span class="p">):</span>
            <span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Preprocess offer &#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span> <span class="o">+</span> <span class="mi">1</span><span class="p">),</span> <span class="n">end</span><span class="o">=</span><span class="s2">&quot;</span><span class="se">\r</span><span class="s2">&quot;</span><span class="p">,</span> <span class="n">flush</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
            <span class="n">text</span> <span class="o">=</span> <span class="n">row</span><span class="p">[</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;feature&#39;</span><span class="p">]]</span>  <span class="c1"># Get the text from the initial offer</span>
            <span class="n">label</span> <span class="o">=</span> <span class="n">row</span><span class="p">[</span><span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;label&#39;</span><span class="p">]]</span>
            <span class="n">add_offer_to_database</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="p">(</span><span class="n">text</span><span class="p">,</span> <span class="n">label</span><span class="p">))</span>
    <span class="nb">print</span><span class="p">()</span>  <span class="c1"># Print a new line to not override lines below</span></div>


<div class="viewcode-block" id="init"><a class="viewcode-back" href="../../../../backend_doc/preprocess.html#SmartRecruiting_BackEnd.deeplearning.preprocess.preprocess.init">[docs]</a><span class="k">def</span> <span class="nf">init</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">generate_w2c</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Function to initialize the model and the database.</span>
<span class="sd">    Has to be called before using the CNN model for the first time or if the csv files (offers, fields, contacts) has changed</span>

<span class="sd">    Populate the database with:</span>
<span class="sd">    - offers with their word descriptor</span>
<span class="sd">    - fields</span>
<span class="sd">    - contacts</span>

<span class="sd">    If generate_w2c if set to True, the word2vec model is build and train.</span>

<span class="sd">    If you run the app with runserver :</span>
<span class="sd">    - Use --init arg to launch this function</span>
<span class="sd">    - Use --word2vec arg to set this flag</span>

<span class="sd">    :param db_manager: database manager</span>
<span class="sd">    :type db_manager: DatabaseManager</span>

<span class="sd">    :param generate_w2c: (optional) True if word2vec model have to be build and train</span>
<span class="sd">    :type generate_w2c: bool</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="n">generate_w2c</span><span class="p">:</span>
        <span class="n">build_word2vec</span><span class="p">()</span>

    <span class="c1"># Put everything in the database</span>
    <span class="n">filename</span> <span class="o">=</span> <span class="n">app</span><span class="o">.</span><span class="n">config</span><span class="p">[</span><span class="s1">&#39;offers_dataset&#39;</span><span class="p">]</span>
    <span class="n">preprocess_all_and_add_to_database</span><span class="p">(</span><span class="n">db_manager</span><span class="p">,</span> <span class="n">filename</span><span class="p">)</span>  <span class="c1"># Preprocess and add offers to the database</span>
    <span class="n">add_fields</span><span class="p">(</span><span class="n">db_manager</span><span class="p">)</span>  <span class="c1"># Add fields to the database</span>
    <span class="n">add_contacts</span><span class="p">(</span><span class="n">db_manager</span><span class="p">)</span>  <span class="c1"># Add contacts to the database</span></div>
</pre></div>

           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, Projet 21

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>